<?php
use \WHMCS\Database\Capsule as Capsule;
add_hook('ShoppingCartValidateCheckout', 1, function($vars) {
	$errors = array();
	$status_cancelled = Capsule::table("tbladdonmodules")->where("module", "buylimit")->where("setting", "status_cancelled")->first()->value;
	$status_terminated = Capsule::table("tbladdonmodules")->where("module", "buylimit")->where("setting", "status_terminated")->first()->value;
	$status_fraud = Capsule::table("tbladdonmodules")->where("module", "buylimit")->where("setting", "status_fraud")->first()->value;
	foreach($_SESSION['cart']['products'] as $product_details){
		if(@$product_details['qty']){
			$CartBuyNum = $product_details['qty'];
		}else{
			$CartBuyNum = 1;
		}
		$DataList = \WHMCS\Database\Capsule::table('mod_buylimit')->where('pid',$product_details['pid'])->first();
		$ProDataList = \WHMCS\Database\Capsule::table('tblproducts')->where('id',$product_details['pid'])->first();
		if($DataList){
			$DataCount = \WHMCS\Database\Capsule::table('tblhosting')->where('userid',intval($_SESSION['uid']))->where('packageid',$DataList->pid);
			if($status_cancelled != 'on'){
				$DataCount->where('domainstatus','!=','Cancelled');
			}
			if($status_terminated != 'on'){
				$DataCount->where('domainstatus','!=','Terminated');
			}
			if($status_fraud != 'on'){
				$DataCount->where('domainstatus','!=','Fraud');
			}
			$DataCount = $DataCount->count();
			if($DataCount >= $DataList->number || $DataCount+$CartBuyNum > $DataList->number){
				$errors[] = $ProDataList->name.'已超过可购买限额 '.$DataList->number;
			}
		}
	}
	return $errors;
});